/*-
 * Copyright (c) 1998 John Galbraith
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * Sun Jul 26 16:37:58 MDT 1998
 */

#include <sys/ioccom.h>

struct gpibconfig
{
  unsigned char address;
  int poll_timeout;
  int irq_timeout;
  int wait_timeout;
  unsigned char eos;
  short eos_enabled;
  short eoi_enabled;
};

/* group execute trigger */
#define GPIB_TRIGGER _IO('g',3)
/* goto local */
#define GPIB_LOCAL _IOW('g',4,short)
/* local lockout */
#define GPIB_LOCKOUT _IOW('g',5,short)
/* global device clear */
#define GPIB_DEVICE_CLEAR _IO('g', 6)
/* selected device clear */
#define GPIB_SELECTED_DEVICE_CLEAR _IO('g', 7)
/* serial poll */
#define GPIB_SPOLL _IOR('g',8,unsigned char)
/* global interface clear */
#define GPIB_INTERFACE_CLEAR _IO('g', 9)
/* enable remote */
#define GPIB_REMOTE_ENABLE _IO('g',10)
#define GPIB_REMOTE_DISABLE _IO('g',14)
/* trigger all devices on bus */
#define GPIB_GROUP_EXECUTE_TRIGGER _IO('g', 11)
/* get configuration info */
#define GPIB_GET_CONFIG _IOR('g',12, struct gpibconfig)
/* set configuration info */
#define GPIB_SET_CONFIG _IOW('g',13, struct gpibconfig)
