#include <stdio.h>
#include <fcntl.h>
#include <unistd.h>
#include <string.h>
#include <sys/conf.h>
#include <sys/time.h>

#include "../module/gpib.h"

int main(int argc, char* argv[])
{
    int gpctl, device;
    struct gpibconfig info;
    char buf[64*1024];
    unsigned long i, size;
    struct timeval start, stop;

    size = 63*1024;
/*     size = 24; */

    gpctl = open("/dev/gp1ctl", O_RDWR);
    if(gpctl == -1)
    {
        perror("gp1ctl");
        exit(-1);
    }

    device = open("/dev/gp1d0", O_RDWR);
    if(device == -1)
    {
        perror("gp1d0");
        exit(-1);
    }

    if(ioctl(gpctl, GPIB_GET_CONFIG, &info) == -1)
    {
        perror("gp ioctl getconfig");
	exit(-1);
    }
    printf("address: %d, eos: 0x%x, poll_timeout: %d, irq_timeout: %d, eoi: %d\n",
           info.address, info.eos, info.poll_timeout, info.irq_timeout, 
           info.eoi);
    info.poll_timeout = 2*100;
    if(ioctl(gpctl, GPIB_SET_CONFIG, &info) == -1)
    {
        perror("gp ioctl setconfig");
	exit(-1);
    }

    for(i = 0; i < size; i++)
        buf[i] = argv[1][0] + i%26;
    buf[i] = 0;

#if 0
    for(i = 0; i < 4; i++)
    {
        if(write(device, buf, size) == -1)
        {
            perror("gp write");
            exit(-1);
        }
        printf("send: %s\n", buf);
    }
    close(device);
    close(gpctl);
    exit(1);
#endif

    while(1)
    {
        gettimeofday(&start, 0);
        for(i = 0; i < 50; i++)
            write(device, buf, size);
        gettimeofday(&stop, 0);
        printf("sent %f bytes per second\n", 50.0*size/(stop.tv_sec-start.tv_sec+stop.tv_usec*1e-6-start.tv_usec*1e-6));
    }
}

